﻿using System;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            this.openApplicationFirewallButton.Click  += openApplicationFirewallButton_Click;
            this.closeApplicationFilewallButton.Click += closeApplicationFilewallButton_Click;
            this.openPortFirewallButton.Click         += openPortFirewallButton_Click;
            this.closePortFirewallButton.Click        += closePortFirewallButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 애플리케이션 방화벽 열기 버튼 클릭시 처리하기 - openApplicationFirewallButton_Click(sender, e)

        /// <summary>
        /// 애플리케이션 방화벽 열기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void openApplicationFirewallButton_Click(object sender, EventArgs e)
        {
            string applicationName     = this.applicationNameTextBox.Text.Trim();
            string applicationFilePath = this.applicationFilePathTextBox.Text.Trim();

            FirewallHelper.OpenApplicationFirewall(applicationName, applicationFilePath);
        }

        #endregion
        #region 애플리케이션 방화벽 닫기 버튼 클릭시 처리하기 - closeApplicationFilewallButton_Click(sender, e)

        /// <summary>
        /// 애플리케이션 방화벽 닫기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void closeApplicationFilewallButton_Click(object sender, EventArgs e)
        {
            string applicationName     = this.applicationNameTextBox.Text.Trim();
            string applicationFilePath = this.applicationFilePathTextBox.Text.Trim();

            FirewallHelper.CloseApplicationFirewall(applicationName, applicationFilePath);
        }

        #endregion

        #region 포트 방화벽 열기 버튼 클릭시 처리하기 - openPortFirewallButton_Click(sender, e)

        /// <summary>
        /// 포트 방화벽 열기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void openPortFirewallButton_Click(object sender, EventArgs e)
        {
            string portName = this.portNameTextBox.Text.Trim();
            string port     = this.portTextBox.Text.Trim();

            FirewallHelper.OpenPortFirewall(portName, Convert.ToInt32(port));
        }

        #endregion
        #region 포트 방화벽 닫기 버튼 클릭시 처리하기 - closePortFirewallButton_Click(sender, e)

        /// <summary>
        /// 포트 방화벽 닫기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void closePortFirewallButton_Click(object sender, EventArgs e)
        {
            string port = this.portTextBox.Text.Trim();

            FirewallHelper.ClosePortFirewall(Convert.ToInt32(port));
        }

        #endregion
    }
}